Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        chkUseListChangeEvent.Checked = Me.GridDataBoundGrid1.UseListChangedEvent
    End Sub

    Private Sub rdoDataSource_Arraylist_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoDataSource_Arraylist.CheckedChanged
        Me.TextBox1.Text = "Source=Arraylist" & vbCrLf
        Dim arraylistObjects As ArrayList = New ArrayList
        Dim i As Integer
        For i = 1 To 5
            arraylistObjects.Add(New TestObject(CStr(i)))
        Next
        Me.GridDataBoundGrid1.DataSource = arraylistObjects
    End Sub

    Private Sub rdoDataSource_Datatable_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoDataSource_Datatable.CheckedChanged
        Me.TextBox1.Text = "Source=Datatable" & vbCrLf
        Dim dt As DataTable = New DataTable
        dt.Columns.Add("Column1")
        dt.Columns.Add("Column2")
        dt.Columns.Add("Column3")
        dt.Rows.Add(New Object() {"1", "2", "3"})
        dt.Rows.Add(New Object() {"1", "2", "3"})
        dt.Rows.Add(New Object() {"1", "2", "3"})
        Me.GridDataBoundGrid1.DataSource = dt
    End Sub

    Private Sub GridDataBoundGrid1_RowEnter(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridRowEventArgs) Handles GridDataBoundGrid1.RowEnter
        Me.TextBox1.Text = Me.TextBox1.Text & "Rowenter " & e.RowIndex & vbCrLf
    End Sub

    Private Sub chkUseListChangeEvent_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkUseListChangeEvent.CheckedChanged
        Me.GridDataBoundGrid1.UseListChangedEvent = chkUseListChangeEvent.Checked
    End Sub

    Private Sub DataGridView1_RowEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs)
        Me.TextBox1.Text = Me.TextBox1.Text & "DataGridView1Rowenter " & e.RowIndex & vbCrLf
    End Sub

    Private Sub GridDataBoundGrid1_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GridDataBoundGrid1.Leave
        Me.GridDataBoundGrid1.Binder.SuspendBinding()
    End Sub

    Private Sub GridDataBoundGrid1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GridDataBoundGrid1.Enter
        Me.GridDataBoundGrid1.Binder.ResumeBinding()
    End Sub
End Class

Friend Class TestObject
    Private _strColumn1 As String
    Sub New(ByVal Column1 As String)
        _strColumn1 = Column1
    End Sub

    Public Property Column1() As String
        Get
            Return _strColumn1
        End Get
        Set(ByVal value As String)
            _strColumn1 = value
        End Set
    End Property
End Class